unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TypInfo;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    isFirst:boolean;
    procedure RecordStart(ASender:TObject);
    procedure ConvertField(ASender:TObject; AFieldName:string; AFieldType:TTypeKind; AFieldTypeData:PTypeData; var AValue:variant);
    procedure RecordEnd(ASender:TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ConvertData;

{$R *.dfm}

type
  TShortString=string[5];
  
  TMyRecordStub=class(TBaseDataConverter)
  private
    FSomeInteger: integer;
    FAByte: byte;
    FShortString: TShortString;
  published
    property SomeInteger:integer read FSomeInteger;
    property AByte:byte read FAByte;
    property SomeShortString:TShortString read FShortString;
  end;

  TMyRecord=packed record//  must be packed, otherwise delphi compiler will align the data to some boundary
    SomeInteger:integer;
    AByte:byte;
    SomeShortString:array[0..4] of char;// translated to TShortString
  end;

procedure TForm1.ConvertField(ASender: TObject; AFieldName: string;
  AFieldType: TTypeKind; AFieldTypeData: PTypeData; var AValue: variant);
begin
  case AFieldType of
    tkInteger:
      AValue:=VarToStr(AValue);
    tkString:
      AValue:=VarToStr(AValue);
    else
      raise Exception.Create('ConvertField does not support field type '+GetEnumName(TypeInfo(TTypeKind), integer(AFieldType)));
  end;
  if not isFirst then
    AValue:=', '+AValue;
  isFirst:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var rec:TMyRecord;
    f:file of TMyRecord;
    s, d:TFileStream;
    r:TBinaryReader;
    w:TCSVWriter;
begin
  rec.SomeInteger:=-5;
  rec.AByte:=7;
  rec.SomeShortString:='5char';
  assignfile(f, 'test.bin');
  rewrite(f);
  try
    write(f, rec);
    write(f, rec);
    write(f, rec);
  finally
    closefile(f);
  end;
  s:=TFileStream.Create('test.bin', fmopenread);
  try
    d:=TFileStream.Create('test.csv', fmcreate);
    try
      r:=TBinaryReader.Create(s);
      try
        w:=TCSVWriter.Create(d);
        try
          with TMyRecordStub.Create(r, w) do
          try
            OnBeforeConvertRecord:=RecordStart;
            OnConvertField:=ConvertField;
            OnAfterConvertRecord:=RecordEnd;
            Convert;
          finally
            free;
          end;
        finally
          freeandnil(w);
        end;
      finally
        freeandnil(r);
      end;
    finally
      freeandnil(d);
    end;
  finally
    freeandnil(s);
  end;
end;

procedure TForm1.RecordEnd(ASender: TObject);
begin
  TMyRecordStub(ASender).FDestination.Stream.Write(pchar(#13#10)^, 2);
end;

procedure TForm1.RecordStart(ASender: TObject);
begin
  isFirst:=true;
end;

end.
